--imports
local Stmt = require("dogma.syn._.Stmt")
local StmtType = require("dogma.syn.StmtType")

--An until statement.
local UntilStmt = {}
UntilStmt.__index = UntilStmt
setmetatable(UntilStmt, {__index = Stmt})
package.loaded[...] = UntilStmt

--Constructor.
--
--@param ln:number
--@param col:number
--@param cond:Exp
--@param iter?:Exp
--@param body:Sent[]
--@param el:Sent[]
--@param catch?:CatchCl
--@param fin?:FinallyCl
function UntilStmt.new(ln, col, cond, iter, body, el, catch, fin)
  local self

  --(1) create
  self = setmetatable(Stmt.new(StmtType.UNTIL, ln, col), UntilStmt)
  self.cond = cond
  self.iter = iter
  self.body = body
  self.el = el
  self.catch = catch
  self.finally = fin

  --(2) return
  return self
end
